# coding: UTF-8

import os
import sys
import cgi
os.chdir(os.environ.get('pythonbin')) # need for next statement
import psycopg2

print "Content-type: text/plain; charset=UTF-8\n"

fld = cgi.FieldStorage()
con = fld.getvalue('con', '')
sql = fld.getvalue('sql', '')
if con == '' or sql == '' :
    print 'input for connection or query.'
    sys.exit()

try :
    connect = psycopg2.connect(con)
    cur = connect.cursor()
except :
    print 'unable to connect to the database.'
    sys.exit()

try :
    cur.execute(sql)
    mes = connect.notices
    col = cur.description
except psycopg2.Error as e :
    print e.pgerror
    sys.exit()

res = []

if col is not None :
    columns = [d[0] for d in col]
    res.append('<table>')
    tr = []
    for c in columns :
        tr.append('<th>' + str(c).decode('utf-8').encode('utf-8') + '</th>')
    res.append(''.join(tr))
    for r in cur.fetchall() :
        tr = ['<tr>']
        for c in r:
            tr.append('<td>' + str(c).decode('utf-8').encode('utf-8') + '</td>')
        tr.append('</tr>')
        res.append(''.join(tr))
    res.append('</table>')

if len(mes) > 0 :
    res.append('<pre>')
    for m in mes :
        res.append(m)
    res.append('</pre>')

cur.close()
connect.close()
print ''.join(res)
