@echo off
title PostgreSQL 9.4.1 and Python 2.7 CGI Server
chcp 932 > nul

set PGDIR=../PostgreSQLPortable-9.4
set CGIDIR=python_cgiserver

:: set up paths for PostgreSQL / PostGIS 
::
set PGSQL=%PGDIR%/App/PgSQL
set PGDATA=%PGDIR%/Data/data
set PGLOG=%PGDIR%/Data/log.txt
set PGLOCALEDIR=%PGSQL%/share
set GDAL_DATA=%PGSQL%/gdal-data
set PATH=%PGSQL%/bin

:: set up variables for PostgreSQL / PostGIS 
::
set PGDATABASE=postgres
set PGUSER=postgres
set POSTGIS_GDAL_ENABLED_DRIVERS=ENABLE_ALL
set POSTGIS_ENABLE_OUTDB_RASTERS=1

:: startup postgres server
::
echo.
"%PGSQL%/bin/pg_ctl" -D "%PGDATA%" -l "%PGLOG%" -w start

:: set up paths and startup Python CGI server
::
cd %CGIDIR%
set PYTHONHOME=../QGIS/apps/Python27
set PYTHONPATH=../QGIS/apps/Python27/Lib
set PYTHONBIN=../QGIS/bin
set PATH=%PYTHONHOME%
"%PYTHONBIN%/python" -m CGIHTTPServer

:: terminate
::
"%PGSQL%/bin/pg_ctl" -D "%PGDATA%" stop
